
#include <gtk/gtk.h>
#include <libxfcegui4/xfce_decorbutton.h>

void iconify(GtkWidget * widget, gpointer data)
{
    gtk_window_iconify(GTK_WINDOW(data));
}

int main(int argc, char *argv[])
{
    /* GtkWidget is the storage type for widgets */
    GtkWidget *window;
    GtkWidget *button_close;
    GtkWidget *decorbutton_close;
    GtkWidget *button_hide;
    GtkWidget *decorbutton_hide;
    GtkWidget *frame;
    GtkWidget *vbox;

    gtk_init(&argc, &argv);

    /* Create a new window */
    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

    gtk_window_set_title(GTK_WINDOW(window), "decorbutton");

    g_signal_connect(G_OBJECT(window), "destroy", G_CALLBACK(gtk_main_quit), NULL);

    g_signal_connect(G_OBJECT(window), "delete_event", G_CALLBACK(gtk_main_quit), NULL);

    /* Sets the border width of the window. */
    gtk_container_set_border_width(GTK_CONTAINER(window), 0);

    frame = gtk_frame_new(NULL);
    gtk_container_set_border_width(GTK_CONTAINER(frame), 0);
    gtk_container_add(GTK_CONTAINER(window), frame);
    gtk_widget_show(frame);

    vbox = gtk_vbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(frame), vbox);
    gtk_widget_show(vbox);

    /* Create a new button */
    button_close = gtk_button_new();

    /* Connect the "clicked" signal of the button to our callback */
    g_signal_connect(G_OBJECT(button_close), "clicked", G_CALLBACK(gtk_main_quit), NULL);

    decorbutton_close = xfce_decorbutton_new(XFCE_DECORBUTTON_CLOSE);
    gtk_widget_show(decorbutton_close);

    gtk_container_add(GTK_CONTAINER(button_close), decorbutton_close);

    gtk_box_pack_end(GTK_BOX(vbox), button_close, TRUE, TRUE, 0);

    gtk_widget_show(button_close);

    /* Create a new button */
    button_hide = gtk_button_new();

    /* Connect the "clicked" signal of the button to our callback */
    g_signal_connect(G_OBJECT(button_hide), "clicked", G_CALLBACK(iconify), (gpointer) window);

    decorbutton_hide = xfce_decorbutton_new(XFCE_DECORBUTTON_HIDE);
    gtk_widget_show(decorbutton_hide);

    gtk_container_add(GTK_CONTAINER(button_hide), decorbutton_hide);

    gtk_box_pack_end(GTK_BOX(vbox), button_hide, TRUE, TRUE, 0);

    gtk_widget_show(button_hide);


    gtk_widget_show(window);

    /* Rest in gtk_main and wait for the fun to begin! */
    gtk_main();

    return 0;
}
