
#include <gtk/gtk.h>
#include <libxfcegui4/xfce_iconbutton.h>

int main(int argc, char *argv[])
{
    /* GtkWidget is the storage type for widgets */
    GtkWidget *window;
    GtkWidget *hbox;
    GtkWidget *vbox;
    GtkWidget *label;
    GtkWidget *image;
    GtkWidget *alignment;
    GtkWidget *iconbutton;
    GdkPixbuf *pb;

    gtk_init(&argc, &argv);

    /* Create a new window */
    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

    gtk_window_set_title(GTK_WINDOW(window), "iconbutton");

    g_signal_connect(G_OBJECT(window), "destroy", G_CALLBACK(gtk_main_quit), NULL);

    g_signal_connect(G_OBJECT(window), "delete_event", G_CALLBACK(gtk_main_quit), NULL);

    /* Sets the border width of the window. */
    gtk_container_set_border_width(GTK_CONTAINER(window), 5);

    vbox = gtk_vbox_new(FALSE, 5);
    gtk_widget_show(vbox);
    gtk_container_add(GTK_CONTAINER(window), vbox);

    hbox = gtk_hbox_new(FALSE, 5);
    gtk_widget_show(hbox);
    gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);

    label = gtk_label_new("The buttons should show this image:");
    gtk_widget_show(label);
    gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);

    pb = gdk_pixbuf_new_from_file("gnome-gmush.png", NULL);

    image = gtk_image_new_from_pixbuf(pb);
    gtk_widget_show(image);
    gtk_box_pack_start(GTK_BOX(hbox), image, FALSE, FALSE, 0);

    /* add three button of different size */
    hbox = gtk_hbox_new(FALSE, 15);
    gtk_widget_show(hbox);
    gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);

    alignment = gtk_alignment_new(0.5, 0.5, 0, 0);
    gtk_widget_show(alignment);
    gtk_box_pack_start(GTK_BOX(hbox), alignment, FALSE, FALSE, 0);

    iconbutton = xfce_iconbutton_new();
    xfce_iconbutton_set_pixbuf(XFCE_ICONBUTTON(iconbutton), pb);
    gtk_widget_show(iconbutton);
    gtk_container_add(GTK_CONTAINER(alignment), iconbutton);

    gtk_widget_set_size_request(iconbutton, 64, 64);

    alignment = gtk_alignment_new(0.5, 0.5, 0, 0);
    gtk_widget_show(alignment);
    gtk_box_pack_start(GTK_BOX(hbox), alignment, FALSE, FALSE, 0);

    /* convenience function */
    iconbutton = xfce_iconbutton_new_from_pixbuf(pb);
    gtk_widget_show(iconbutton);
    gtk_container_add(GTK_CONTAINER(alignment), iconbutton);

    gtk_widget_set_size_request(iconbutton, 32, 32);

    alignment = gtk_alignment_new(0.5, 0.5, 0, 0);
    gtk_widget_show(alignment);
    gtk_box_pack_start(GTK_BOX(hbox), alignment, FALSE, FALSE, 0);

    /* convenience function */
    iconbutton = xfce_iconbutton_new_from_pixbuf(pb);
    gtk_widget_show(iconbutton);
    gtk_container_add(GTK_CONTAINER(alignment), iconbutton);

    gtk_widget_set_size_request(iconbutton, 24, 24);

    gtk_widget_show(window);

    /* Rest in gtk_main and wait for the fun to begin! */
    gtk_main();

    return 0;
}
