
#include <gtk/gtk.h>
#include <libxfcegui4/xfce_togglebutton.h>

void toggled(GtkWidget * widget, gpointer data)
{
    g_message("Toggled!");
    if(xfce_togglebutton_get_active(XFCE_TOGGLEBUTTON(data)))
    {
        g_message(" active.\n");
    }
    else
    {
        g_message(" inactive.\n");
    }
}

int main(int argc, char *argv[])
{
    /* GtkWidget is the storage type for widgets */
    GtkWidget *window;
    GtkWidget *frame;
    GtkWidget *table;
    GtkWidget *alignment;
    GtkWidget *togglebutton;

    gtk_init(&argc, &argv);

    /* Create a new window */
    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

    gtk_window_set_title(GTK_WINDOW(window), "togglebutton");

    g_signal_connect(G_OBJECT(window), "destroy", G_CALLBACK(gtk_main_quit), NULL);

    g_signal_connect(G_OBJECT(window), "delete_event", G_CALLBACK(gtk_main_quit), NULL);

    /* Sets the border width of the window. */
    gtk_container_set_border_width(GTK_CONTAINER(window), 0);

    frame = gtk_frame_new(NULL);
    gtk_container_set_border_width(GTK_CONTAINER(frame), 0);
    gtk_container_add(GTK_CONTAINER(window), frame);
    gtk_widget_show(frame);

    table = gtk_table_new(3, 3, TRUE);
    gtk_container_add(GTK_CONTAINER(frame), table);
    gtk_widget_show(table);

    alignment = gtk_alignment_new(0.0, 0.0, 1.0, 1.0);
    gtk_table_attach_defaults(GTK_TABLE(table), alignment, 0, 1, 0, 1);
    gtk_widget_show(alignment);

    togglebutton = xfce_togglebutton_new(GTK_ARROW_UP);
    g_signal_connect(togglebutton, "toggled", G_CALLBACK(toggled), togglebutton);
    gtk_table_attach_defaults(GTK_TABLE(table), togglebutton, 1, 2, 0, 1);
    gtk_widget_show(togglebutton);

    alignment = gtk_alignment_new(0.0, 0.0, 1.0, 1.0);
    gtk_table_attach_defaults(GTK_TABLE(table), alignment, 2, 3, 0, 1);
    gtk_widget_show(alignment);

    togglebutton = xfce_togglebutton_new(GTK_ARROW_LEFT);
    g_signal_connect(togglebutton, "toggled", G_CALLBACK(toggled), togglebutton);
    gtk_table_attach_defaults(GTK_TABLE(table), togglebutton, 0, 1, 1, 2);
    gtk_widget_show(togglebutton);

    alignment = gtk_alignment_new(0.0, 0.0, 1.0, 1.0);
    gtk_table_attach_defaults(GTK_TABLE(table), alignment, 1, 2, 1, 2);
    gtk_widget_show(alignment);

    togglebutton = xfce_togglebutton_new(GTK_ARROW_RIGHT);
    g_signal_connect(togglebutton, "toggled", G_CALLBACK(toggled), togglebutton);
    gtk_table_attach_defaults(GTK_TABLE(table), togglebutton, 2, 3, 1, 2);
    gtk_widget_show(togglebutton);

    alignment = gtk_alignment_new(0.0, 0.0, 1.0, 1.0);
    gtk_table_attach_defaults(GTK_TABLE(table), alignment, 0, 1, 2, 3);
    gtk_widget_show(alignment);

    togglebutton = xfce_togglebutton_new(GTK_ARROW_DOWN);
    g_signal_connect(togglebutton, "toggled", G_CALLBACK(toggled), togglebutton);
    gtk_table_attach_defaults(GTK_TABLE(table), togglebutton, 1, 2, 2, 3);
    gtk_widget_show(togglebutton);

    alignment = gtk_alignment_new(0.0, 0.0, 1.0, 1.0);
    gtk_table_attach_defaults(GTK_TABLE(table), alignment, 2, 3, 2, 3);
    gtk_widget_show(alignment);

    gtk_widget_show(window);

    /* Rest in gtk_main and wait for the fun to begin! */
    gtk_main();

    return 0;
}
